<?php
class CCR_Button_Widget extends WP_Widget {
	// Construct
	public function __construct() {
	    parent::__construct(
		        'ccr_button_widget', // Base ID
		        __( 'ccRobot', 'ccr-domain' ), // Name
		        array( 'description' => __( 'A button to start ccRobot chatbot', 'ccr-domain' ), ) // Args
		        );
	}

	// Display widget
	public function widget($args, $instance) {
        $data = array();
        $data['host_url'] = esc_attr($instance['host_url']);
        $data['organization_id'] = esc_attr($instance['organization_id']);
        $data['chat_title'] = esc_attr($instance['chat_title']);
        $data['btn_size'] = esc_attr($instance['btn_size']);
        $data['lang'] = esc_attr($instance['lang']);
        $data['notice_msg'] = esc_attr($instance['notice_msg']);
        $data['show_msg_timeout'] = esc_attr($instance['show_msg_timeout']);
		$data['hide_msg_timeout'] = esc_attr($instance['hide_msg_timeout']);
		$data['is_show_min_btn'] = (isset( $instance['is_show_min_btn'] ) && $instance['is_show_min_btn'] == '1') ? "true" : "false";
        $data['is_show_resize_btn'] = (isset( $instance['is_show_resize_btn'] ) && $instance['is_show_resize_btn'] == '1') ? "true" : "false";
        $data['is_show_close_btn'] = (isset( $instance['is_show_close_btn'] ) && $instance['is_show_close_btn'] == '1') ? "true" : "false";
        $data['is_show_confirmation_on_close'] = (isset( $instance['is_show_confirmation_on_close'] ) && $instance['is_show_confirmation_on_close'] == '1') ? "true" : "false";
        $data['is_private_info_allow'] = (isset( $instance['is_private_info_allow'] ) && $instance['is_private_info_allow'] == '1') ? "true" : "false";
        $data['base_url'] = esc_attr($instance['base_url']);
        $data['is_check_ccr_availability'] = (isset( $instance['is_check_ccr_availability'] ) && $instance['is_check_ccr_availability'] == '1') ? "true" : "false";
        $data['is_auto_popup'] = (isset( $instance['is_auto_popup'] ) && $instance['is_auto_popup'] == '1') ? "true" : "false";
        
//         echo $args['before_widget'];
                
        // Get main content
        echo $this->getPagePlugin($data);
                
//         echo $args['after_widget'];
	}

	// Backend Widget Form
	public function form($instance) {
	   $this->getAdminForm($instance);
	}

	// Update Values
	public function update($new_instance, $old_instance) {
	    $instance = array(
	        'chat_title' => (!empty($new_instance['chat_title'])) ? strip_tags($new_instance['chat_title']) : 'Virtual assistant',
	        'host_url' => (!empty($new_instance['host_url'])) ? strip_tags($new_instance['host_url']) : 'https://black.korahlimited.com/oprCns/',
	        'organization_id' => (!empty($new_instance['organization_id'])) ? strip_tags($new_instance['organization_id']) : '14C20537-F311-B294-662C-C144D90A9444',
	        'btn_size' => (!empty($new_instance['btn_size'])) ? strip_tags($new_instance['btn_size']) : 75,
	        'notice_msg' => (!empty($new_instance['notice_msg'])) ? strip_tags($new_instance['notice_msg']) : 'You have questions about our new website? Let\'s chat.',
	        'show_msg_timeout' => (!empty($new_instance['show_msg_timeout'])) ? strip_tags($new_instance['show_msg_timeout']) : 3000,
	        'hide_msg_timeout' => (!empty($new_instance['hide_msg_timeout'])) ? strip_tags($new_instance['hide_msg_timeout']) : 5000,
	        'lang' => (!empty($new_instance['lang'])) ? strip_tags($new_instance['lang']) : 'default',
	        'is_show_min_btn' => (isset( $new_instance['is_show_min_btn'] ) && (int) $new_instance['is_show_min_btn'] == 1) ? '1' : '0',
	        'is_show_resize_btn' => (isset( $new_instance['is_show_resize_btn'] ) && (int) $new_instance['is_show_resize_btn'] == 1) ? '1' : '0',
	        'is_show_close_btn' => (isset( $new_instance['is_show_close_btn'] ) && (int) $new_instance['is_show_close_btn'] == 1) ? '1' : '0',
	        'is_show_confirmation_on_close' => (isset( $new_instance['is_show_confirmation_on_close'] ) && (int) $new_instance['is_show_close_btn'] == 1 && (int) $new_instance['is_show_confirmation_on_close'] == 1) ? '1' : '0',
	        'is_private_info_allow' => (isset( $new_instance['is_private_info_allow'] ) && (int) $new_instance['is_private_info_allow'] == 1) ? '1' : '0',
	        'base_url' => (!empty($new_instance['base_url'])) ? strip_tags($new_instance['base_url']) : (plugins_url('../js/',  __FILE__ )),
			'is_check_ccr_availability' => (isset( $new_instance['is_check_ccr_availability'] ) && (int) $new_instance['is_check_ccr_availability'] == 1) ? '1' : '0',
			'is_auto_popup' => (isset( $new_instance['is_auto_popup'] ) && (int) $new_instance['is_auto_popup'] == 1) ? '1' : '0'
	    );
	    if(!empty($instance['chat_title']) && !empty($instance['notice_msg'])) {
			$this->updateResoures($instance['chat_title'], $instance['notice_msg']);
		}
	    return $instance;

	}
	
	public function getAdminForm($instance){
   	    $chat_title = !empty($instance['chat_title']) ? $instance['chat_title'] : 'Virtual assistant';
	    $host_url = !empty($instance['host_url']) ? $instance['host_url'] : 'https://black.korahlimited.com/oprCns/';
	    $organization_id = !empty($instance['organization_id']) ? $instance['organization_id'] : '14C20537-F311-B294-662C-C144D90A9444'; //korah
		$btn_size = !empty($instance['btn_size']) ? $instance['btn_size'] : 75;
		$lang = !empty($instance['lang']) ? $instance['lang'] : 'default';
	    $notice_msg = !empty($instance['notice_msg']) ? $instance['notice_msg'] : 'You have questions about our new website? Let\'s chat.';
	    $show_msg_timeout = !empty($instance['show_msg_timeout']) ? $instance['show_msg_timeout'] : 3000;
		$hide_msg_timeout = !empty($instance['hide_msg_timeout']) ? $instance['hide_msg_timeout'] : 5000;
		$is_show_min_btn = isset( $instance['is_show_min_btn'] ) ? $instance['is_show_min_btn'] : '1';
		$is_show_resize_btn = isset( $instance['is_show_resize_btn'] ) ? $instance['is_show_resize_btn'] : '1';
		$is_show_close_btn = isset( $instance['is_show_close_btn'] ) ? $instance['is_show_close_btn'] : '1';
		$is_show_confirmation_on_close = isset( $instance['is_show_confirmation_on_close'] ) ? $instance['is_show_confirmation_on_close'] : '1';
		$is_private_info_allow = isset( $instance['is_private_info_allow'] ) ? $instance['is_private_info_allow'] : '0';
		$base_url = isset( $instance['base_url'] ) ? $instance['base_url'] : (plugins_url('../js/',  __FILE__ ));
		$is_check_ccr_availability = isset( $instance['is_check_ccr_availability'] ) ? $instance['is_check_ccr_availability'] : '0';
		$is_auto_popup = isset( $instance['is_auto_popup'] ) ? $instance['is_auto_popup'] : '0';
	    
		?>
			<style>
				.ccrGroup {
					border: 2px solid #CCCCCC !important;
				}
				.ccrTitle {
					background-color: #333; 
					color: #fff; 
					padding: 5px;
				}
				.ccrChild {
					padding: 0px 10px;
				}
			</style>
			<p>
				<label for="<?php echo $this->get_field_id('chat_title'); ?>"><?php _e('Title','ccr-domain'); ?></label>
				<input 
					class="widefat"
					type="text"  
					id="<?php echo $this->get_field_id('chat_title'); ?>"
					name="<?php echo $this->get_field_name('chat_title'); ?>"
					value="<?php echo esc_attr($chat_title); ?>"
				>
			</p>
			<fieldset class="ccrGroup">
				<legend class="ccrTitle">Your ID</legend>
				<p class="ccrChild">
					<label for="<?php echo $this->get_field_id('organization_id'); ?>"><?php _e('Organization ID','ccr-domain'); ?></label>
					<input 
						class="widefat"
						type="text" 
						maxlength="36" 
						id="<?php echo $this->get_field_id('organization_id'); ?>"
						name="<?php echo $this->get_field_name('organization_id'); ?>"
						value="<?php echo esc_attr($organization_id); ?>"
					>
				</p>
				<p class="ccrChild">
					<label for="<?php echo $this->get_field_id('host_url'); ?>"><?php _e('Host URL','ccr-domain'); ?></label>
					<input 
						class="widefat"
						type="text" 
						id="<?php echo $this->get_field_id('host_url'); ?>"
						name="<?php echo $this->get_field_name('host_url'); ?>"
						value="<?php echo esc_attr($host_url); ?>"
					>
				</p>
			</fieldset>
			<p>
				<label for="<?php echo $this->get_field_id('btn_size'); ?>"><?php _e('Widget size (pixels)','ccr-domain'); ?></label>
				<input 
					class="widefat"
					type="number" 
					min="75"
					max="150"
					id="<?php echo $this->get_field_id('btn_size'); ?>"
					name="<?php echo $this->get_field_name('btn_size'); ?>"
					value="<?php echo esc_attr($btn_size); ?>"
				>
			</p>
			<p>
				<label for="<?php echo $this->get_field_id('lang'); ?>"><?php _e('Language','ccr-domain'); ?></label>
				<select 
					class="widefat"
					type="text" 
					id="<?php echo $this->get_field_id('lang'); ?>"
					name="<?php echo $this->get_field_name('lang'); ?>"
					value="<?php echo esc_attr($lang); ?>"
				>
				<option value="default" <?php echo ($lang == 'default') ? 'selected' : ''; ?>></option>
				<option value="en" <?php echo ($lang == 'en') ? 'selected' : ''; ?>>English</option>
				<option value="fr" <?php echo ($lang == 'fr') ? 'selected' : ''; ?>>French</option>
				</select>
			</p>
			<fieldset class="ccrGroup">
				<legend class="ccrTitle">Notice Message</legend>
				<p class="ccrChild">
					<label for="<?php echo $this->get_field_id('notice_msg'); ?>"><?php _e('Message','ccr-domain'); ?></label>
					<textarea 
						class="widefat"
						id="<?php echo $this->get_field_id('notice_msg'); ?>"
						name="<?php echo $this->get_field_name('notice_msg'); ?>"
					><?php echo esc_attr($notice_msg); ?></textarea>
				</p>
				<p class="ccrChild">
					<label for="<?php echo $this->get_field_id('show_msg_timeout'); ?>"><?php _e('Time until notice message is displayed (milliseconds)','ccr-domain'); ?></label>
					<input 
						class="widefat"
						type="number" 
						min="1000" 
						max="10000" 
						id="<?php echo $this->get_field_id('show_msg_timeout'); ?>"
						name="<?php echo $this->get_field_name('show_msg_timeout'); ?>"
						value="<?php echo esc_attr($show_msg_timeout); ?>"
					>
				</p>
				<p class="ccrChild">
					<label for="<?php echo $this->get_field_id('hide_msg_timeout'); ?>"><?php _e('Notice message timeout (milliseconds)','ccr-domain'); ?></label>
					<input 
						class="widefat"
						type="number" 
						min="1000" 
						max="10000" 
						id="<?php echo $this->get_field_id('hide_msg_timeout'); ?>"
						name="<?php echo $this->get_field_name('hide_msg_timeout'); ?>"
						value="<?php echo esc_attr($hide_msg_timeout); ?>"
					>
				</p>
			</fieldset>
			<p><input hidden></p>
			<fieldset class="ccrGroup">
				<legend class="ccrTitle">Title Bar Buttons</legend>
				<p class="ccrChild">
					<input 
						type="checkbox"
						name="<?php echo $this->get_field_name('is_show_min_btn'); ?>"
						id="<?php echo $this->get_field_id('is_show_min_btn'); ?>"
						value="1"
						<?php 
							checked( '1', esc_attr($is_show_min_btn));
						?>
					>
					<label for="<?php echo $this->get_field_id('is_show_min_btn'); ?>"><?php _e('Show minimize button','ccr-domain'); ?></label>
				</p>
				<p class="ccrChild">
					<input 
						type="checkbox"
						name="<?php echo $this->get_field_name('is_show_resize_btn'); ?>"
						id="<?php echo $this->get_field_id('is_show_resize_btn'); ?>"
						value="1"
						<?php 
							checked( '1', esc_attr($is_show_resize_btn));
						?>
					>
					<label for="<?php echo $this->get_field_id('is_show_resize_btn'); ?>"><?php _e('Show resize button','ccr-domain'); ?></label>
				</p>
				<p class="ccrChild">
					<input 
						type="checkbox"
						name="<?php echo $this->get_field_name('is_show_close_btn'); ?>"
						id="<?php echo $this->get_field_id('is_show_close_btn'); ?>"
						value="1"
						<?php 
							checked( '1', esc_attr($is_show_close_btn));
						?>
					>
					<label for="<?php echo $this->get_field_id('is_show_close_btn'); ?>"><?php _e('Show close button','ccr-domain'); ?></label>
				</p>
				<p class="ccrChild">
					<input 
						type="checkbox"
						name="<?php echo $this->get_field_name('is_show_confirmation_on_close'); ?>"
						id="<?php echo $this->get_field_id('is_show_confirmation_on_close'); ?>"
						value="1"
						<?php 
							checked( '1', esc_attr($is_show_confirmation_on_close));
						?>
					>
					<label for="<?php echo $this->get_field_id('is_show_confirmation_on_close'); ?>"><?php _e('Provide confirmation on close','ccr-domain'); ?></label>
				</p>
			</fieldset>
			<p>
				<input 
					type="checkbox"
					name="<?php echo $this->get_field_name('is_auto_popup'); ?>"
					id="<?php echo $this->get_field_id('is_auto_popup'); ?>"
					value="1"
					<?php 
						checked( '1', esc_attr($is_auto_popup));
					?>
				>
				<label for="<?php echo $this->get_field_id('is_auto_popup'); ?>"><?php _e('Automatically pop up on first visit','ccr-domain'); ?></label>
			</p>
			<p>
				<input 
					type="checkbox"
					name="<?php echo $this->get_field_name('is_private_info_allow'); ?>"
					id="<?php echo $this->get_field_id('is_private_info_allow'); ?>"
					value="1"
					<?php 
						checked( '1', esc_attr($is_private_info_allow));
					?>
				>
				<label for="<?php echo $this->get_field_id('is_private_info_allow'); ?>"><?php _e('Require user to identify themselves','ccr-domain'); ?></label>
			</p>
			<p>
				<input 
					type="checkbox"
					name="<?php echo $this->get_field_name('is_check_ccr_availability'); ?>"
					id="<?php echo $this->get_field_id('is_check_ccr_availability'); ?>"
					value="1"
					<?php 
						checked( '1', esc_attr($is_check_ccr_availability));
					?>
				>
				<label for="<?php echo $this->get_field_id('is_check_ccr_availability'); ?>"><?php _e('Check for ccRobot service availability','ccr-domain'); ?></label>
			</p>
		<?php 	    
	}

	// update j18Locale.js
	public function updateResoures($newChatTitle, $newNoticeMsg) {
		$locRes = 'var ccrResources = {
	"en": {
		"translation": {
			"ChatNow": "Chat with Virtual assistant",
			"chatTitle": "' . $newChatTitle . '",
			"ccrChatToolbarRegion": "Chat dialog control bar",
			"goToInput": "Go to input",
			"MinChat": "Minimize chat dialog",
			"MaxChat": "Maximize chat dialog",
			"RestoreChat": "Restore chat dialog to default size",
			"CloseChat": "Close chat dialog",
			"confirmationEnd": "End",
			"confirmationEndTitle": "End chat session and close dialog",
			"confirmationMinimize": "Minimize",
			"confirmationMinimizeTitle": "Minimize chat",
			"confirmationCancel": "Back",
			"confirmationCancelTitle": "Cancel and continue conversation",
			"chatDialogOpened": "Chat dialog opened",
			"chatDialogClosed": "Chat dialog closed",
			"chatDialogMinimized": "Chat dialog minimized",
			"NoPersonalInfo": "No personal information",
			"TermsOfUse": "Terms of use",
			"modalTitle": "Chat service",
			"noticeMsg": "' . $newNoticeMsg . '",
			"ccrChatFrameTitle": "Chat conversation"
		}
	},
	"fr": {
		"translation": {
			"ChatNow": "Clavarder avec l’assistant virtuel",
			"chatTitle": "' . $newChatTitle . '",
			"ccrChatToolbarRegion": "Barre de commande de la fenêtre de clavardage",
			"goToInput": "Aller à l’écran de saisie",
			"MinChat": "Réduire la fenêtre de clavardage",
			"MaxChat": "Agrandir la fenêtre de clavardage",
			"RestoreChat": "Rétablir la taille par défaut de la fenêtre de clavardage",
			"CloseChat": "Fermer la fenêtre de clavardage",
			"confirmationEnd": "Terminer",
			"confirmationEndTitle": "Terminer la session de clavardage et fermer la fenêtre",
			"confirmationMinimize": "Réduire",
			"confirmationMinimizeTitle": "Réduire la session de clavardage",
			"confirmationCancel": "Retour",
			"confirmationCancelTitle": "Annuler et poursuivre la conversation",
			"chatDialogOpened": "Fenêtre de clavardage ouverte",
			"chatDialogClosed": "Fenêtre de clavardage fermée",
			"chatDialogMinimized": "Fenêtre de clavardage réduite",
			"NoPersonalInfo": "Aucune information personnelle",
			"TermsOfUse": "Conditions d’utilisation",
			"modalTitle": "Service de clavardage",
			"noticeMsg": "' . $newNoticeMsg . '",
			"ccrChatFrameTitle": "Conversation par clavardage"
		}
	}
};';
		
		$fname = dirname(__FILE__) . '/../js/i18Locale.js';
		if(empty($data)) {
			$data = 'nothing found';
		}
		if( ($file = fopen($fname, "w+")) !== FALSE ) {
			fputs($file, $locRes);
			fclose($file);
		} else {
			die($fname . ' is not found.');
		}
	}
	
	// Show Frontend Content
	public function getPagePlugin($data){
	    ?>
	    <div class="ccrobot"> 
			<iframe id="korahCcrChatContainer"
				data-chattitle="<?php echo $data['chat_title']; ?>"
                style="visibility:hidden;"
                data-hosturl="<?php echo $data['host_url']; ?>"
                data-ccrchatphpurl = "ccrChat.php"
                data-orgid="<?php echo $data['organization_id']; ?>"
                data-lang="<?php echo $data['lang']; ?>"
                data-btnwidth=<?php echo $data['btn_size'] . "px" ;  ?>
                data-btnheight=<?php echo $data['btn_size'] . "px" ;  ?>
                data-noticemsg="<?php echo $data['notice_msg']; ?>"
                data-showmsgtimeout="<?php echo $data['show_msg_timeout']; ?>"
                data-hidemsgtimeout="<?php echo $data['hide_msg_timeout']; ?>"
                data-isshowminbtn="<?php echo $data['is_show_min_btn']; ?>"
                data-isshowresizebtn="<?php echo $data['is_show_resize_btn']; ?>"
                data-isshowclosebtn="<?php echo $data['is_show_close_btn']; ?>"
                data-isshowconfirmationonclose="<?php echo $data['is_show_confirmation_on_close']; ?>"
                data-isprivateinfoallowed="<?php echo $data['is_private_info_allow']; ?>"
                data-isclntauthrq="false"
                data-ischeckccravailability="<?php echo $data['is_check_ccr_availability']; ?>"
				data-isautopopup="<?php echo $data['is_auto_popup']; ?>"
                data-baseurl="<?php echo $data['base_url']; ?>"
                src="about:blank">
			</iframe>
		</div>
	    	    
	    <?php 
	}
}
?>